package com.zswl.cloud.springBtach.server.core.service;

import com.github.microservice.auth.client.content.ResultContent;
import com.zhongshu.payment.client.model.order.v2.CreateOrder2Model;
import com.zswl.cloud.springBatch.client.model.CreateOrderModel;
import com.zswl.cloud.springBatch.client.service.OrderService;
import com.zswl.cloud.springBatch.client.type.JobFlowMap;
import com.zswl.cloud.springBatch.client.type.JobFlowType;
import com.zswl.cloud.springBtach.server.core.job.standard.StandardOrderJob;
import lombok.SneakyThrows;
import org.springframework.batch.core.Job;
import org.springframework.batch.core.JobParameters;
import org.springframework.batch.core.JobParametersBuilder;
import org.springframework.batch.core.explore.JobExplorer;
import org.springframework.batch.core.launch.JobLauncher;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

@Service
public class OrderServiceImp implements OrderService {

    @Autowired
    private StandardOrderJob standardOrderJob;

    @Resource
    private JobLauncher jobLauncher;

    @Resource
    private JobExplorer jobExplorer;


    @Autowired
    private ApplicationContext applicationContext;


    @Override
    @SneakyThrows
    public ResultContent creat(CreateOrderModel createOrderModel) {
        JobFlowMap jobFlowMap = createOrderModel.getJobFlowMap();
        String jobName = jobFlowMap.getJobMapping().get(JobFlowType.CrateOrder);
        ThreadLocal<CreateOrder2Model> parameter = standardOrderJob.getParameter();
        parameter.set(createOrderModel);
        Job job = (Job) applicationContext.getBean(jobName);
        JobParameters parameters = new JobParametersBuilder(jobExplorer)
                .getNextJobParameters(job)
                .toJobParameters();
        jobLauncher.run(job, parameters).getExitStatus();
        return standardOrderJob.getResultContent().get();
    }
}
